
//-------------------------------------------------------------------
//
//	TIP ANIMATION v1.2 (12.08.2008) by Tebe/Madteam & Lewis/Aids
//
//	!!! TIP-y o rozmiarze 160x100 !!!
//
//-------------------------------------------------------------------


delay	= 1		; jeli dziaa za szybko mona spowolni :)
banks	= 6		; liczba bankw = liczbie plikw DIC?.DAT wygenerowanych przez TIPANM.EXE


	org $80

h	.ds 2
p	.ds 2
q	.ds 2
w	.ds 2
r	.ds 2
t	.ds 2


//-------------------------------------------------------------------

@TAB_MEM_BANKS = $0600

	org $2000

init	jsr @mem_detect
	cmp #banks
	bcs ok

	jsr printf
	.by 'I need extended RAM' $9b 0

	pla
	pla

ok	rts

	.link '@mem_detect.obx'
	.link 'printf.obx'

	ini init


//-------------------------------------------------------------------

@PROC_ADD_BANK	= $2000

	opt b+

	lmb #0
	ins 'dic0.dat'			; pliki DIC?.DAT wygenerowane przez TIPANM.EXE

	nmb
	ins 'dic1.dat'

	nmb
	ins 'dic2.dat'

	nmb
	ins 'dic3.dat'

	nmb
	ins 'dic4.dat'

	nmb
	ins 'dic5.dat'

	rmb
	opt b-


//-------------------------------------------------------------------

	org $1000

anm	ins 'anm.dat'			; plik ANM.DAT wygenerowany przez TIPANM.EXE


	.align

lcol	:128 dta l(TIPANM.column+#*16)
hcol	:128 dta h(TIPANM.column+#*16)

	.align $400

dl1	.ds $400
dl2	.ds $400

	ert *>$3fff


//-------------------------------------------------------------------
//-------------------------------------------------------------------

	org $8000

gr9	ins '0001.tip',9,100*40			; inicjacja przy pomocy pierwszej klatki animacji

	.align $1000
gra	ins '0001.tip',9+100*40,100*40

	.align $1000
grb	ins '0001.tip',9+100*40+100*40,100*40


start	mva #$ff $d301

	jsr mktipdl

	jsr ramka

	jsr tip

//-------------------------------------------------------------------

	mwa #anm TIPANM.ad

	jmp TIPANM.main

//-------------------------------------------------------------------

ramka	lda:cmp:req 20
	rts

tip	mva #$00 $22f
	mva #$7f $d40e

	ldx #8
tip2	lda kolory,x
	sta $2c0,x
	dex
	bpl tip2

	mwa #dl1 $230

	mwa #dli $200

	mva #$c0 $d40e
	mva #$22 $22f

	jsr ramka
	rts

mktipdl	lda #$70
	:2 sta dl1+#
	:2 sta dl2+#

	lda #$10+$80
	sta dl1+2
	sta dl2+2

	mwa #gr9 h
	mwa #gra p
	mwa #grb q

	mwa #dl1+3 w
	mwa #dl2+3 r

	ldx #50

mkt1	ldy #0
	lda #$4f
	sta (w),y
	sta (r),y
	iny
	lda q
	sta (w),y
	sta (r),y
	iny
	lda q+1
	sta (w),y
	sta (r),y
	iny

	lda #$4f
	sta (w),y
	sta (r),y
	iny
	mva h (w),y
	mva p (r),y
	iny
	mva h+1 (w),y
	mva p+1 (r),y
	iny

	adw h #$28
	adw p #$28
	adw q #$28

	lda #$4f
	sta (w),y
	sta (r),y
	iny
	lda q
	sta (w),y
	sta (r),y
	iny
	lda q+1
	sta (w),y
	sta (r),y
	iny

	lda #$4f
	sta (w),y
	sta (r),y
	iny
	mva p (w),y
	mva h (r),y
	iny
	mva p+1 (w),y
	mva h+1 (r),y
	iny

	adw h #$28
	adw p #$28
	adw q #$28

	dex
	beq mkt11

	adw w #12
	adw r #12

	jmp mkt1

mkt11	lda #$41
	sta (w),y
	sta (r),y
	iny

	mva #<dl1 (r),y
	mva #<dl2 (w),y
	iny
	mva #>dl1 (r),y
	mva #>dl2 (w),y
	rts

kolory .he 0 2 4 6 8 a c e 0

//-------------------------------------------------------------------

dli	pha
	txa
	pha
	tya
	pha

	ldx #$c0
	ldy #$76
dli1	lda #$40
dli2	sta $d40a
	stx $d01b
	sta $d40a
	sta $d01b
	eor #$c0
	dey
	bne dli2

	eor #$c0
	sta dli1+1

	pla
	tay
	pla
	tax

dli3	lda #>dl2
	eor #(>dl1)^(>dl2)
	sta dli3+1
	sta $231

	pla
	rti

//-------------------------------------------------------------------

.local	TIPANM

	.zpvar ad, b0, b1, b2, tmp .word height, px, py .byte = $80

nbank	inc bank+1
bank	ldx #0
	cpx #banks
	bne skp

	ldx #0
	stx bank+1

	mwa #anm-1 ad

skp	lda @TAB_MEM_BANKS,x
	sta $d301


next	inw ad

	ldx #delay
wait	jsr ramka		; delay
	dex
	bne wait

MAIN	ldy #0

loop	lda (ad),y

	cmp #$ff
	beq nbank

	and #$7f
	beq next

	sta height		; wysokosc kolumny

	iny
	mva (ad),y  px		; pozycja pozioma

	iny
	mva (ad),y  py		; pozycja pionowa

	iny
	mwa (ad),y b0

	iny
	mwa (ad),y b1

	iny
	mwa (ad),y b2

;	iny
	tya
	sec			; +1
	adc ad
	sta ad
	scc
	inc ad+1
;	lda #0
;	adc ad+1
;	sta ad+1


	ldy py
	mva lcol,y _jsr+1
	mva hcol,y _jsr+2

	tya
	add height
	tay
	lda lcol,y
	sub #1
	sta tmp
	lda hcol,y
	sbc #0
	sta tmp+1

	ldy #0
	lda #{rts}
	sta (tmp),y

	ldx px

_jsr	jsr column

	ldy #0
	lda #{iny}
	sta (tmp),y

	jmp loop

column	.rept 110
	mva	(b0),y	gr9+#*40,x
	mva	(b1),y	gra+#*40,x
	mva	(b2),y	grb+#*40,x
	iny
	.endr

.end


//-------------------------------------------------------------------

	.print 'end: ',*

	run start

//-------------------------------------------------------------------

	icl '@bank_add.mac'
